#include "whiptk/whip_toolkit.h"

extern WT_File whip_file; //Assume this has been opened for writing elsewhere.

WT_Result ColorMap()
{
    //Store the old color map.
    WT_Color_Map old_color_map = whip_file.desired_rendition().color_map();
    //Create the new color map.
    WT_RGB rgb[3];
    rgb[0] = WT_RGB(255,0,0); //red
    rgb[1] = WT_RGB(0,255,0); //green
    rgb[2] = WT_RGB(0,0,255); //blue
    WT_Color_Map color_map(3, rgb, whip_file);
    //Set the new color map active.
    whip_file.desired_rendition().color_map() = color_map;
    //Draw some geometry with the new color map.
    whip_file.desired_rendition().color() = WT_Color(0, whip_file.desired_rendition().color_map());
    WT_Text text = WT_Text(WT_Logical_Point(0, 0), WT_String("Red"));
    WD_CHECK(text.serialize(whip_file));
    whip_file.desired_rendition().color() = WT_Color(1, whip_file.desired_rendition().color_map());
    text = WT_Text(WT_Logical_Point(150, 0), WT_String("Green"));
    WD_CHECK(text.serialize(whip_file));
    whip_file.desired_rendition().color() = WT_Color(2, whip_file.desired_rendition().color_map());
    text = WT_Text(WT_Logical_Point(350, 0), WT_String("Blue"));
    WD_CHECK(text.serialize(whip_file));
    //Resotre the old color map.
    whip_file.desired_rendition().color_map() = old_color_map;
    return WT_Result::Success;
}