#include "whiptk/whip_toolkit.h"

extern WT_File whip_file; //Assume this has been opened for writing elsewhere.

//Creates a diamond with a hole containing another interior diamond.
WT_Result ContourSet()
{
    //Define the contour coordinates
    int x=0,y=0;
    WT_Logical_Point diamonds[12]; 
    diamonds[0] = WT_Logical_Point(x, y+200); //positive space (winds clockwise)
    diamonds[1] = WT_Logical_Point(x+200, y); 
    diamonds[2] = WT_Logical_Point(x, y-200);
    diamonds[3] = WT_Logical_Point(x-200, y);
    diamonds[4] = WT_Logical_Point(x, y+150); //negative space (winds counterclockwise)
    diamonds[5] = WT_Logical_Point(x-150, y);
    diamonds[6] = WT_Logical_Point(x, y-150);
    diamonds[7] = WT_Logical_Point(x+150, y); 
    diamonds[8] = WT_Logical_Point(x, y+100); //positive space (winds clockwise)
    diamonds[9] = WT_Logical_Point(x+100, y); 
    diamonds[10] = WT_Logical_Point(x, y-100);
    diamonds[11] = WT_Logical_Point(x-100, y);
    //Define the number of points per contour (3 contours, 4 points each).
    WT_Integer32 contour_counts[3] = {4,4,4};
    //Create the contour set.
    WT_Contour_Set diamond_contour(whip_file, 3, contour_counts, 12, diamonds, WD_True);
    //Serialize it.
    WD_CHECK(diamond_contour.serialize(whip_file));
 
    return WT_Result::Success;
}