#include "whiptk/whip_toolkit.h"

void FileWrite(const WT_String& filename)
{
    WT_File        whip_file;
    //Set the filename and open mode.    
    whip_file.set_filename (filename);
    whip_file.set_file_mode (WT_File::File_Write);
    //Set a different target version here if you don't want the current file version... for example:
    //whip_file.heuristics().set_target_version(42); //produce a DWF ver 00.42

    if (WT_Result::Success == whip_file.open())
    {
        //Set the binary data and compression settings.
        whip_file.heuristics().set_allow_binary_data(true);
        whip_file.heuristics().set_allow_data_compression(true);

        //Write file data.

        whip_file.close();
    }
}