#include "whiptk/whip_toolkit.h"

extern WT_File whip_file; //Assume this has been opened for writing elsewhere.

WT_Result Layer()
{
    //Store the current layer.
    WT_Layer current_layer = whip_file.desired_rendition().layer();
    //Define some polylines.
    int x=0,y=0;
    WT_Logical_Point vP[4];
    vP[0] = WT_Logical_Point(x,y);
    vP[1] = WT_Logical_Point(x+50,y);
    vP[2] = WT_Logical_Point(x,y+100);
    vP[3] = WT_Logical_Point(x+50,y+100);
    //Create the polylines.
    WT_Polyline p1 (2, vP, WD_True);
    WT_Polyline p2 (2, &vP[2], WD_True);
    //Serialize them, associated with different layers.
    whip_file.desired_rendition().layer() = WT_Layer(whip_file, 1, "Layer 1");
    WD_CHECK(p1.serialize (whip_file));
    whip_file.desired_rendition().layer() = WT_Layer(whip_file, 2, "Layer 2");
    WD_CHECK(p2.serialize (whip_file));
    //Restore the saved layer.
    whip_file.desired_rendition().layer() = current_layer;

    return WT_Result::Success;
}