#include "whiptk\whip_toolkit.h"

void WriteBlocks()
{
    WT_File file1, file2, file;

    file.set_filename("c:\\test.dwf");
    file.heuristics().set_target_version(55);

    file1.set_filename("c:\\test1.dwf");
    file1.heuristics().set_target_version(55);

    file2.set_filename("c:\\test2.dwf");
    file2.heuristics().set_target_version(55);

    file.set_file_mode(WT_File::Block_Write);
    file.open();

    WT_BlockRef graphics_ref;
    graphics_ref.set_format(WT_BlockRef::WT_BlockRef_Format::Graphics);

    GUID _guid;
    CoCreateGuid(&_guid);
    WD_GUID guid;
    memcpy(&guid,&_guid,sizeof(guid));

    WT_Guid graphics_block_guid(guid);
    graphics_ref.set_block_guid(graphics_block_guid);

    FILETIME ft;
    GetSystemTimeAsFileTime(&ft);

    WT_FileTime graphics_creation_time(ft.dwLowDateTime, ft.dwHighDateTime);
    graphics_ref.set_creation_time(graphics_creation_time);

    WT_FileTime graphics_modification_time(ft.dwLowDateTime, ft.dwHighDateTime);
    graphics_ref.set_modification_time(graphics_modification_time);
    graphics_ref.set_validity(WD_True);

    file.desired_rendition().blockref() = graphics_ref;
    file.write_block(file1);

    WT_BlockRef overlay_ref;
    overlay_ref.set_format(WT_BlockRef::WT_BlockRef_Format::Overlay);

    CoCreateGuid(&_guid);
    memcpy(&guid,&_guid,sizeof(guid));

    WT_Guid overlay_block_guid(guid);
    overlay_ref.set_block_guid(overlay_block_guid);

    WT_FileTime overlay_creation_time(ft.dwLowDateTime, ft.dwHighDateTime);
    overlay_ref.set_creation_time(overlay_creation_time);

    WT_FileTime overlay_modification_time(ft.dwLowDateTime, ft.dwHighDateTime);
    overlay_ref.set_modification_time(overlay_modification_time);
    overlay_ref.set_validity(WD_True);

    file.desired_rendition().blockref() = overlay_ref;

    file.write_block(file2);
    file.close();
}